; Author:      Roy Klein Gebbinck (www.b-k-g.nl)
; Version:     20180711: First version.
; Created for: https://forum.bricsys.com/discussion/33839/anonymous-blocks?

;;RenameBlk.lsp modified 
;;Renames anonymous blocks by adding "U" in front of the name and refedits the block to send the BM_Visible layer to the front with draworder.
;;Closes and saves the block

(defun KGA_Sys_ApplyAlt (expr varLst)
  (not (vl-catch-all-error-p (vl-catch-all-apply expr varLst)))
)

(defun c:Vis2front ( / blk doc enm nme obj)
  (setq doc (vla-get-activedocument (vlax-get-acad-object)))
  (vla-endundomark doc)
  (vla-startundomark doc)
  (if
    (and
      (setq enm (car (entsel "\nSelect insert: ")))
      (setq lpnt (getvar "lastpoint"))
      (setq anonb (vle-cdrassoc 2 (entget enm)))
      (setq obj (vlax-ename->vla-object enm))
      (or
        (= "AcDbBlockReference" (vla-get-objectname obj))
        (prompt "\nError: not an insert ")
      )
      (setq blk (vla-item (vla-get-blocks doc) (vla-get-name obj)))
      (or
        (= :vlax-false (vla-get-isxref blk))
        (prompt "\nError: this is an insert of an xref ")
      )
      (setq nme (strcat "U" anonb))
    )
    (KGA_Sys_ApplyAlt 'vla-put-name (list blk nme))
  )
  (vla-endundomark doc)
  (BM_vis_front)
  (princ)
)

(defun BM_vis_front (/)
  (command "-refedit" lpnt "o" "a" "y")
  (command "draworder" (ssget "x" '((8 . "BM_Visible" ))) "" "_f")
  (command "refclose" "s")
)